// Copyright:	(C) Alexander S. Naumov aka GooRoo, 2004.
// E-mail:		gooroo@bk.ru
// Last update:	23/05/2004

using System;

namespace LoCoL.Logs
{
	/// <summary>
	/// ,    ,
	///   .
	/// </summary>
	public interface ILogDetailer
	{

		#region Methods

		/// <summary>
		/// ,   
		///   .
		/// </summary>
		bool IsEnabledBeginCycle( AutomatonManager manager );

		/// <summary>
		/// ,   
		///     .
		/// </summary>
		bool IsEnabledBeginNotificationProcessing(
			Automaton automaton,
			Notification notification );

		/// <summary>
		/// ,   
		///   .
		/// </summary>
		bool IsEnabledInputInquire(
			Automaton automaton,
			InputVariable variable );

		/// <summary>
		/// ,   
		///   .
		/// </summary>
		bool IsEnabledNotificationChecking(
			Automaton automaton,
			Notification notification );

		/// <summary>
		/// ,   
		///      .
		/// </summary>
		bool IsEnabledStateChecking(
			Automaton automaton,
			Automaton checkedAutomaton,
			State state );

		/// <summary>
		/// ,   
		///  .
		/// </summary>
		bool IsEnabledTransition( Automaton automaton, Transition transition );

		/// <summary>
		/// ,   
		///   .
		/// </summary>
		bool IsEnabledOutputInvocation(
			Automaton automaton,
			OutputAction action );

		/// <summary>
		/// ,   
		///  .
		/// </summary>
		bool IsEnabledSendMessage(
			Automaton targetAutomaton,
			Notification notification );

		/// <summary>
		/// ,   
		///    .
		/// </summary>
		bool IsEnabledEndNotificationProcessing(
			Automaton automaton,
			Notification notification );

		/// <summary>
		/// ,   
		///   .
		/// </summary>
		bool IsEnabledEndCycle( AutomatonManager manager );

		#endregion

	}
}
