// Copyright:	(C) Alexander S. Naumov aka GooRoo, 2004.
// E-mail:		gooroo@bk.ru
// Last update:	23/05/2004

using System;

namespace LoCoL.Logs
{
	/// <summary>
	/// ,    ,
	///    .
	/// </summary>
	public interface ILogger
	{

		#region Methods

		/// <summary>
		///    .
		/// </summary>
		void OnBeginCycle( AutomatonManager manager );

		/// <summary>
		///      .
		/// </summary>
		void OnBeginNotificationProcessing(
			Automaton automaton,
			Notification notification );

		/// <summary>
		///    .
		/// </summary>
		void OnInputInquire(
			Automaton automaton,
			InputVariable variable,
			bool result );

		/// <summary>
		///    .
		/// </summary>
		void OnNotificationChecking(
			Automaton automaton,
			Notification notification,
			bool result );

		/// <summary>
		///       .
		/// </summary>
		void OnStateChecking(
			Automaton automaton,
			Automaton checkedAutomaton,
			State state,
			bool result );

		/// <summary>
		///   .
		/// </summary>
		void OnTransition( Automaton automaton, Transition transition );

		/// <summary>
		///    .
		/// </summary>
		void OnOutputInvocation( Automaton automaton, OutputAction action );

		/// <summary>
		///   .
		/// </summary>
		void OnSendMessage(
			Automaton targetAutomaton,
			Notification notification );

		/// <summary>
		///     .
		/// </summary>
		void OnEndNotificationProcessing(
			Automaton automaton,
			Notification notification );

		/// <summary>
		///    .
		/// </summary>
		void OnEndCycle( AutomatonManager manager );

		#endregion

		#region Properties

		/// <summary>
		/// ,   .
		/// </summary>
		ILogDetailer LogDetailer
		{
			get;
			set;
		}

		#endregion

	}
}
