// Copyright:	(C) Alexander S. Naumov aka GooRoo, 2004.
// E-mail:		gooroo@bk.ru
// Last update:	23/05/2004

using System;

namespace LoCoL.Exceptions
{

	/// <summary>
	///     .
	/// </summary>
	public class LoCoLException : ApplicationException
	{

		#region Public Constructors

		/// <summary>
		/// .
		/// </summary>
		public LoCoLException()
			: base()
		{
		}

		/// <summary>
		/// .
		/// </summary>
		public LoCoLException( string message )
			: base( message )
		{
		}

		/// <summary>
		/// .
		/// </summary>
		public LoCoLException( string message, Exception innerException )
			: base( message, innerException )
		{
		}

		#endregion

	}

	/// <summary>
	///   .
	/// </summary>
	public class LoCoLCollectionsException : LoCoLException
	{

		#region Public Constructors

		/// <summary>
		/// .
		/// </summary>
		public LoCoLCollectionsException()
			: base()
		{
		}

		/// <summary>
		/// .
		/// </summary>
		public LoCoLCollectionsException( string message )
			: base( message )
		{
		}

		/// <summary>
		/// .
		/// </summary>
		public LoCoLCollectionsException(
			string message,
			Exception innerException )
			: base( message, innerException )
		{
		}

		#endregion

	}

	/// <summary>
	/// ,   Automaton.
	/// </summary>
	public class AutomatonException : LoCoLException
	{

		#region Public Constructors

		/// <summary>
		/// .
		/// </summary>
		public AutomatonException()
			: base()
		{
		}

		/// <summary>
		/// .
		/// </summary>
		public AutomatonException( string message )
			: base( message )
		{
		}

		/// <summary>
		/// .
		/// </summary>
		public AutomatonException( string message, Exception innerException )
			: base( message, innerException )
		{
		}

		#endregion

	}

	/// <summary>
	/// ,   AutomatonManager.
	/// </summary>
	public class AutomatonManagerException : LoCoLException
	{

		#region Public Constructors

		/// <summary>
		/// .
		/// </summary>
		public AutomatonManagerException()
			: base()
		{
		}

		/// <summary>
		/// .
		/// </summary>
		public AutomatonManagerException( string message )
			: base( message )
		{
		}

		/// <summary>
		/// .
		/// </summary>
		public AutomatonManagerException(
			string message,
			Exception innerException )
			: base( message, innerException )
		{
		}

		#endregion

	}

	/// <summary>
	/// ,      ,
	///   <see cref="LoCoL.IValidCheckable"/>.
	/// </summary>
	public class CheckValidException : LoCoLException
	{

		#region Public Constructors

		/// <summary>
		/// .
		/// </summary>
		public CheckValidException()
			: base()
		{
		}

		/// <summary>
		/// .
		/// </summary>
		public CheckValidException( string message )
			: base( message )
		{
		}

		/// <summary>
		/// .
		/// </summary>
		public CheckValidException( string message, Exception innerException )
			: base( message, innerException )
		{
		}

		#endregion

	}

	/// <summary>
	/// ,   Condition.
	/// </summary>
	public class ConditionException : LoCoLException
	{

		#region Public Constructors

		/// <summary>
		/// .
		/// </summary>
		public ConditionException()
			: base()
		{
		}

		/// <summary>
		/// .
		/// </summary>
		public ConditionException( string message )
			: base( message )
		{
		}

		/// <summary>
		/// .
		/// </summary>
		public ConditionException( string message, Exception innerException )
			: base( message, innerException )
		{
		}

		#endregion

	}

	/// <summary>
	/// ,   Transition.
	/// </summary>
	public class TransitionException : LoCoLException
	{

		#region Public Constructors

		/// <summary>
		/// .
		/// </summary>
		public TransitionException()
			: base()
		{
		}

		/// <summary>
		/// .
		/// </summary>
		public TransitionException( string message )
			: base( message )
		{
		}

		/// <summary>
		/// .
		/// </summary>
		public TransitionException( string message, Exception innerException )
			: base( message, innerException )
		{
		}

		#endregion

	}

	/// <summary>
	/// ,   SendNotificationAction.
	/// </summary>
	public class SendNotificationActionException : LoCoLException
	{

		#region Public Constructors

		/// <summary>
		/// .
		/// </summary>
		public SendNotificationActionException()
			: base()
		{
		}

		/// <summary>
		/// .
		/// </summary>
		public SendNotificationActionException( string message )
			: base( message )
		{
		}

		/// <summary>
		/// .
		/// </summary>
		public SendNotificationActionException(
			string message,
			Exception innerException )
			: base( message, innerException )
		{
		}

		#endregion

	}
	

	/// <summary>
	/// ,  ,   ILogger.
	/// </summary>
	public class LoggerException : LoCoLException
	{

		#region Public Constructors

		/// <summary>
		/// .
		/// </summary>
		public LoggerException()
			: base()
		{
		}

		/// <summary>
		/// .
		/// </summary>
		public LoggerException( string message )
			: base( message )
		{
		}

		/// <summary>
		/// .
		/// </summary>
		public LoggerException( string message, Exception innerException )
			: base( message, innerException )
		{
		}

		#endregion

	}
}
